/* $Log:	loadpkfile.c,v $
 * Revision 0.8  92/11/23  19:46:48  19:46:48  bt (Bo Thide')
 * Fixed resolution bug. Portable downloading. Added/changed options. PJXL color support
 * 
 * Revision 0.7  92/11/13  02:41:32  02:41:32  bt (Bo Thide')
 * More bug fixes and improvements. Support for PaintJet XL
 * 
 * Revision 0.6  92/11/10  21:47:48  21:47:48  bt (Bo Thide')
 * Bug fixes. Added -R option. Better font handling.
 * 
 * Revision 0.5  92/11/09  16:25:36  16:25:36  bt (Bo Thide')
 * Rewrite of dospecial.c. Extended \special support
 * 
 * Revision 0.4  92/11/08  02:45:52  02:45:52  bt (Bo Thide')
 * Changed to portable bit manipulations. Replaced strrstr for non-POSIX compliant C. Fixed numerous bugs. Added support for more \special's.
 * 
 * Revision 0.3  92/08/24  12:45:43  12:45:43  bt (Bo Thide')
 * Fixed 8 bit (dc font) support.
 * 
 * Revision 0.2  92/08/23  17:28:57  17:28:57  bt (Bo Thide')
 * Source cleaned up.  Changed certain function calls.  Removed globals.
 * 
 * Revision 0.1  92/08/22  23:58:47  23:58:47  bt (Bo Thide')
 * First Release.
 *  */

/*
 * Here is a procedure that reads the .pk file into 'pkbuffer'. Other than
 * insuring that the initial two bytes are 247 and 89 (the pk_pre command,
 * followed by the current .pk format identifier), it does no format checks.
 * If the corresponding .pk file doesn't fit into pkbuffer, 'dvi2pcl' will be
 * aborted. In this case MAXPKSIZE has to be increased by an appropriate
 * amount and 'dvi2pcl' has to be recompiled. At this state the choosen value
 * of MAXPKSIZE will serve all existing .pk files but for future .pk font
 * files this might happen.
 */

#include <stdio.h>
#include "globals.h"
#include "macros.h"
#include "pk.h"

static char rcsid[] = "$Header: loadpkfile.c,v 0.8 92/11/23 19:46:48 bt Exp $";

extern FILE	*openpkfile();

void loadpkfile()
{ 
	FILE	*pkfile;
	long	*pkptr;
	byte	*p;

	pkfile = openpkfile();
	pkptr = pkbuffer;
	p = (byte *) pkptr;
	if(verbose)
		fprintf(stderr,"Trying to load %s\n",pkname);
	*pkptr++ = (long)getw(pkfile);
	if((getpubyte(p) != PK_PRE) || (getpubyte(p) != PK_ID))
		fprintf(stderr,".pk file corrupt -- not loaded\n");
	else { 
		while((*pkptr++ = (long)getw(pkfile)) != EOF) { 
			if(pkptr - pkbuffer >= MAXPKSIZE)
				prerror("Memory size exceeded when loading .pk file\n");
		}
		font->down = -2;
	}
	fclose(pkfile);
}
